$z-index: () !default;
/// Return Z-Index
/// @access public
/// @param {string} $value
@function z-index($value) {
  @return map-get($z-index, $value);
}


$iconMap: () !default;
/// Return Icon from map
/// @access public
/// @param {string} $name
@function icon($name) {
  @return map-get($iconMap, $name);
}


/// Return first item of map
/// @access public
/// @param {list} $map
@function first($map) {
  @return nth($map, 1);
}


/// Return last item of map
/// @access public
/// @param {list} $map
@function last($map) {
  @return nth($map, length($map));
}


$color-grey: () !default;
@function color-gray($shade) {
  @return nth($color-grey, $shade);
}


/// darken color
/// @access public
/// @param {color|string} $color
/// @param {number} $l
@function _darken($color, $l) {
  @if (type-of($color) == 'color') {
    @return darken($color, $l);
  } @else {
    $color-h: var(#{$color+'-h'});
    $color-s: var(#{$color+'-s'});
    $color-l: var(#{$color+'-l'});

    @return hsl(
        $color-h,
        $color-s,
        calc(#{$color-l} - #{$l}),
    );
  }
}


/// lighten color
/// @access public
/// @param {color|string} $color
/// @param {number} $l
@function _lighten($color, $l) {
  @if (type-of($color) == 'color') {
    @return lighten($color, $l);
  } @else {
    $color-h: var(#{$color+'-h'});
    $color-s: var(#{$color+'-s'});
    $color-l: var(#{$color+'-l'});

    @return hsl(
        $color-h,
        $color-s,
        calc(#{$color-l} + #{$l}),
    );
  }
}
